----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY test1_top_tb is

end ENTITY test1_top_tb;

ARCHITECTURE behavioral of test1_top_tb is

COMPONENT test1_top is
port (
	clk : in  std_logic;
	sig0 : in  std_logic;
	sig1 : in  std_logic;
	clkout0 : out  std_logic;
	clkout1 : out  std_logic;
	anded : out  std_logic;
	ored : out  std_logic
);
end COMPONENT;

	signal clk :  std_logic;
	signal sig0 :  std_logic;
	signal sig1 :  std_logic;
	signal clkout0 :  std_logic;
	signal clkout1 :  std_logic;
	signal anded :  std_logic;
	signal ored :  std_logic;
	signal sim_done : boolean := false;

begin

inst_test1_top : test1_top
	port map(
		clk => clk,
		sig0 => sig0,
		sig1 => sig1,
		clkout0 => clkout0,
		clkout1 => clkout1,
		anded => anded,
		ored => ored
	);

-- clk = 25MHz
clk_proc : process 
	begin
		if (not sim_done) then
			clk <= '0';
			wait for 20 ns;
			clk <= '1';
			wait for 20 ns;
		else
			report "sim_done";
			wait; --wait forever
		end if;
	end process clk_proc;
	
and_or_test : process
	begin
		sig0 <= '0';
		sig1 <= '0';
		wait for 30 ns;
		sig0 <= '0';
		sig1 <= '1';
		wait for 20 ns;
		sig0 <= '1';
		sig1 <= '0';
		wait for 20 ns;
		sig0 <= '1';
		sig1 <= '1';
		wait for 20 ns;
		sig0 <= '0';
		sig1 <= '0';
		wait;
	end process;
		
ctrl_proc : process
	begin
		wait for 100 ns;
		sim_done <= true;
		wait;
	end process ctrl_proc;


end;

