----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY test3_top is
port (
	clk : in  std_logic;
	rst : in  std_logic;
	strobe1 : in  std_logic;
	strobe2 : in  std_logic;
	addr : in std_logic_vector(2 downto 0);
	data_out : out std_logic_vector(7 downto 0)
);
end test3_top;

architecture RTL of test3_top is
	signal mux1_en :  std_logic;
	signal mux2_en :  std_logic;
begin

	proc_mux_ctrl : process (all)
	begin
	if rst = '1' then
	mux1_en <= '0';
	mux2_en <= '0';
	else
	if (strobe1 = '1') AND (strobe2 = '1') then
	mux1_en <= NOT addr(2);
	mux2_en <= addr(2);
	else
	mux1_en <= '0';
	mux2_en <= '0';
	end if;
	end if;
	end process;

	
	four_bit_mux1 : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => mux1_en,
		OUT_SEL => addr(1 downto 0),
		MUX_IN0 => x"00",
		MUX_IN1 => x"05",
		MUX_IN2 => x"0A",
		MUX_IN3 => x"0F"
	);
	
	four_bit_mux2 : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => mux2_en,
		OUT_SEL => addr(1 downto 0),
		MUX_IN0 => x"10",
		MUX_IN1 => x"15",
		MUX_IN2 => x"1A",
		MUX_IN3 => x"1F"
	);
end RTL;


