----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;


ENTITY test5_top is
port (
	rst : in  std_logic;
	csn : in  std_logic;
	oen : in  std_logic;
	wrn : in  std_logic;
	addr : in std_logic_vector(7 downto 0);
	rd_str : out std_logic_vector(3 downto 0);
	wr_str : out std_logic_vector(3 downto 0)
);
end test5_top;

architecture RTL of test5_top is
	signal chip_sel :  std_logic;
	signal rd_en :  std_logic;
	signal wr_en :  std_logic;
begin
	chip_sel <= NOT csn;
	rd_en <= NOT oen;
	wr_en <= NOT wrn;
	inst_addr_decode_addr_decode : addr_decode port map (
		rst => rst,
		cs => chip_sel,
		oe => rd_en,
		we => wr_en,
		addr => addr(1 downto 0),
		rd_strobe => rd_str,
		wr_strobe => wr_str
	);
end RTL;


