----------------------------------------------------
--  COMS W4115 PLT - 2014 Spring Term Project
--              HL-HDL compiler
--             Woon Lee (wgl2107)
----------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

package globals is

-- Constants and global signals declaration
	constant VERSION : std_logic_vector(7 downto 0) := x"10";
	constant REVISION : std_logic_vector(7 downto 0) := x"20";
	signal REG0 : std_logic_vector(7 downto 0);
	signal REG1 : std_logic_vector(7 downto 0);
	signal REG2 : std_logic_vector(7 downto 0);
	signal REG3 : std_logic_vector(7 downto 0);
	signal REG4 : std_logic_vector(7 downto 0);
	signal REG5 : std_logic_vector(7 downto 0);
	signal REG6 : std_logic_vector(7 downto 0);
	signal REG7 : std_logic_vector(7 downto 0);
	signal REG8 : std_logic_vector(7 downto 0);
	signal REG9 : std_logic_vector(7 downto 0);
	signal REG10 : std_logic_vector(7 downto 0);
	signal REG11 : std_logic_vector(7 downto 0);
	signal REG12 : std_logic_vector(7 downto 0);
	signal REG13 : std_logic_vector(7 downto 0);
	signal REG14 : std_logic_vector(7 downto 0);
	signal REG15 : std_logic_vector(7 downto 0);

-- Components declaration
component decode_2_to_4 is
port (
	rst : in  std_logic;
	strb_in : in  std_logic;
	in_2bit : in std_logic_vector(1 downto 0);
	strb_out : out std_logic_vector(3 downto 0)
);
end component decode_2_to_4;

component reg_read is
port (
	rst : in  std_logic;
	strb_in : in  std_logic;
	addr_in : in std_logic_vector(3 downto 0);
	data_out : out std_logic_vector(7 downto 0)
);
end component reg_read;

end globals;


-- Entities and architectures of the components
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY decode_2_to_4 is
port (
	rst : in  std_logic;
	strb_in : in  std_logic;
	in_2bit : in std_logic_vector(1 downto 0);
	strb_out : out std_logic_vector(3 downto 0)
);
end decode_2_to_4;

architecture RTL of decode_2_to_4 is
begin

	proc_rst_cond : process (all)
	begin
	if rst = '1' then
	strb_out <= x"0";
	else
	if in_2bit = "00" then
	strb_out(0) <= strb_in;
	strb_out(3 downto 1) <= "000";
	else
	if in_2bit = "01" then
	strb_out(0) <= '0';
	strb_out(1) <= strb_in;
	strb_out(3 downto 2) <= "00";
	else
	if in_2bit = "10" then
	strb_out(1 downto 0) <= "00";
	strb_out(2) <= strb_in;
	strb_out(3) <= '0';
	else
	strb_out(2 downto 0) <= "000";
	strb_out(3) <= strb_in;
	end if;
	end if;
	end if;
	end if;
	end process;

end RTL;

configuration CFG_decode_2_to_4 of decode_2_to_4 is
	for RTL
	end for;
end CFG_decode_2_to_4;

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.globals.all;
use work.lib_comp.all;

ENTITY reg_read is
port (
	rst : in  std_logic;
	strb_in : in  std_logic;
	addr_in : in std_logic_vector(3 downto 0);
	data_out : out std_logic_vector(7 downto 0)
);
end reg_read;

architecture RTL of reg_read is
	signal bank_en : std_logic_vector(3 downto 0);
begin
	bank_sel_decode_2_to_4 : decode_2_to_4 port map (
		rst => rst,
		strb_in => strb_in,
		in_2bit => addr_in(3 downto 2),
		strb_out => bank_en
	);
	
	first_bank : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => bank_en(0),
		OUT_SEL => addr_in(1 downto 0),
		MUX_IN0 => REG0,
		MUX_IN1 => REG1,
		MUX_IN2 => REG2,
		MUX_IN3 => REG3
	);
	
	second_bank : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => bank_en(1),
		OUT_SEL => addr_in(1 downto 0),
		MUX_IN0 => REG4,
		MUX_IN1 => REG5,
		MUX_IN2 => REG6,
		MUX_IN3 => REG7
	);
	
	third_bank : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => bank_en(2),
		OUT_SEL => addr_in(1 downto 0),
		MUX_IN0 => REG8,
		MUX_IN1 => REG9,
		MUX_IN2 => REG10,
		MUX_IN3 => REG11
	);
	
	fourth_bank : MUX_n_bit
 	generic map(num_bits => 8)
 	port map (
		MUX_OUT => data_out,
		EN => bank_en(3),
		OUT_SEL => addr_in(1 downto 0),
		MUX_IN0 => REG12,
		MUX_IN1 => REG13,
		MUX_IN2 => REG14,
		MUX_IN3 => REG15
	);
end RTL;

configuration CFG_reg_read of reg_read is
	for RTL
	end for;
end CFG_reg_read;



